package com.frk.mycode;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.text.DecimalFormat;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

import org.dom4j.DocumentException;
import org.json.JSONArray;
import org.json.JSONObject;

public class OpencloverRunUtil {
	public static final String FAILURE = "FAILURE";

	public static String execCMD(String filepath) {
		String OpencloverRun = "";
		try {
			BufferedReader bufferedReader = null;
			Process process = null;
			OpencloverRun = "cmd /c mvn -file " + filepath + " clean clover:setup test clover:aggregate clover:clover";
			process = Runtime.getRuntime().exec(OpencloverRun);
			bufferedReader = new BufferedReader(new InputStreamReader(process.getInputStream()));
			String line = null;
			while ((line = bufferedReader.readLine()) != null) {
				if (line.contains("BUILD FAILURE")) {
					OpencloverRun = "FAILURE";
				}
//				System.out.println(line);
			}
			bufferedReader.close();
			process.destroy();
			process = null;
		} catch (IOException e) {
			// e.printStackTrace();
			OpencloverRun = "FAILURE";
		}
		return OpencloverRun;
	}
	
	@SuppressWarnings("static-access")
	public static String execSSH(String filepath) {
		Runtime runtime = Runtime.getRuntime();
		String JcovRun = "";
		try {
			BufferedReader bufferedReader = null;
			Process process = null;
			JcovRun = "/usr/bin/env mvn -f " + filepath + " clean clover:setup test clover:aggregate clover:clover";
			// System.out.println(jacocoRun);
			process = runtime.getRuntime().exec(JcovRun);
			bufferedReader = new BufferedReader(new InputStreamReader(process.getInputStream()));
			String line = null;
			while ((line = bufferedReader.readLine()) != null) {
				// System.out.println(line);
				if (line.contains("BUILD FAILURE")) {
					JcovRun = "FAILURE";
				}
			}
			bufferedReader.close();
			process.destroy();
			process = null;
		} catch (IOException e) {
			// e.printStackTrace();
			JcovRun = "FAILURE";
		}
		return JcovRun;
	}
	
	@SuppressWarnings("static-access")
	public static String execSSH2(String filepath) {
		Runtime runtime = Runtime.getRuntime();
		String JcovRun = "";
		try {
			BufferedReader bufferedReader = null;
			Process process = null;
			JcovRun = "/usr/local/bin/mvn -f " + filepath + " clean clover:setup test clover:aggregate clover:clover";
			// System.out.println(jacocoRun);
			process = runtime.getRuntime().exec(JcovRun);
			bufferedReader = new BufferedReader(new InputStreamReader(process.getInputStream()));
			String line = null;
			while ((line = bufferedReader.readLine()) != null) {
				// System.out.println(line);
				if (line.contains("BUILD FAILURE")) {
					JcovRun = "FAILURE";
				}
			}
			bufferedReader.close();
			process.destroy();
			process = null;
		} catch (IOException e) {
			// e.printStackTrace();
			JcovRun = "FAILURE";
		}
		return JcovRun;
	}

	@SuppressWarnings("static-access")
	public static String execSSH3(String filepath) {
		Runtime runtime = Runtime.getRuntime();
		String JcovRun = "";
		try {
			BufferedReader bufferedReader = null;
			Process process = null;
			JcovRun = "mvn -f " + filepath + " clean clover:setup test clover:aggregate clover:clover";
			// System.out.println(jacocoRun);
			process = runtime.getRuntime().exec(JcovRun);
			bufferedReader = new BufferedReader(new InputStreamReader(process.getInputStream()));
			String line = null;
			while ((line = bufferedReader.readLine()) != null) {
				// System.out.println(line);
				if (line.contains("BUILD FAILURE")) {
					JcovRun = "FAILURE";
				}
			}
			bufferedReader.close();
			process.destroy();
			process = null;
		} catch (IOException e) {
			// e.printStackTrace();
			JcovRun = "FAILURE";
		}
		return JcovRun;
	}
	
	public static void parseXML(String filepath) throws DocumentException {
		String resultpath = filepath + "/target/mcnode/result";
		File resultDir = new File(resultpath);
		if (!resultDir.exists())
			resultDir.mkdirs();
		String inputXMLFilePath = filepath + "/target/site/clover/clover.xml";
		String outputCatchNodeFilePath = filepath + "/target/mcnode/result/coverage.json";
		String outputNodeFilePath = filepath + "/target/mcnode/result/project.json";
		String outputColorNodeFilePath = filepath + "/target/mcnode/result/color.json";

		 String[] args= {inputXMLFilePath, outputCatchNodeFilePath,
		 outputNodeFilePath, outputColorNodeFilePath};
		 ParseXML.main(args);
		 
	}

	public static JSONArray CatchJson(String path) {
		String laststr = "";
		JSONArray catchnode = new JSONArray();
		File file = new File(path);
		if (file.exists()) {
			System.out.println("here is coverage");
			BufferedReader reader = null;
			try {
				reader = new BufferedReader(new FileReader(file));
				String tempString = null;
				// int line=1;
				while ((tempString = reader.readLine()) != null) {
					// System.out.println("line"+line+":"+tempString);
					laststr = laststr + tempString;
					// line++;
				}
				catchnode = new JSONArray(laststr);
				reader.close();
			} catch (IOException e) {
				e.printStackTrace();
				return catchnode;
			} finally {
				if (reader != null) {
					try {
						reader.close();
					} catch (IOException el) {
						return catchnode;
					}
				}
			}
			// System.out.println(catchnode);
			return catchnode;
		} else {
			System.out.println("no coverage");
			System.out.println(path);
			return catchnode;
		}

	}

	public static JSONObject CatchObject(String path) {

		String laststr = "";
		JSONObject catchnode = new JSONObject();
		File file = new File(path);
		if (file.exists()) {
			System.out.println("here is coverage");
			BufferedReader reader = null;
			try {
				reader = new BufferedReader(new FileReader(file));
				String tempString = null;
				// int line=1;
				while ((tempString = reader.readLine()) != null) {
					// System.out.println("line"+line+":"+tempString);
					laststr = laststr + tempString;
					// line++;
				}
				catchnode = new JSONObject(laststr);
				reader.close();
			} catch (IOException e) {
				e.printStackTrace();
				return catchnode;
			} finally {
				if (reader != null) {
					try {
						reader.close();
					} catch (IOException el) {
						return catchnode;
					}
				}
			}
			return catchnode;
		} else {
			System.out.println("no coverage");
			System.out.println(path);
			return catchnode;
		}
	}

	public static String[] CalculateNode(JSONArray catchNode, JSONObject templateNode) {
		String[] score = new String[3];
		double[] sum = { 0, 0, 0 };
		double[] covered = { 0, 0, 0 };
		JSONArray nodes = new JSONArray(templateNode.get("nodes").toString());
		double weight = 0;
		System.out.println(catchNode.length());
		System.out.println(templateNode.length());
		if (catchNode.length() > 0 && templateNode.length() > 0) {
			Map<String, Double> NodeMap = new HashMap<String, Double>();
			for (int j = 0; j < nodes.length(); j++) {
				JSONObject tnode = new JSONObject(nodes.get(j).toString());
				NodeMap.put(tnode.get("name").toString(),
						(double) 1/* Double.parseDouble(tnode.get("weight").toString()) */);
			}
			for (int i = 0; i < catchNode.length(); i++) {
				if (catchNode.get(i).toString().contains("statement")) {
					JSONObject node = new JSONObject(catchNode.get(i).toString());
					weight = NodeMap.get(node.get("nodeName").toString());
					sum[0] = sum[0] + weight;
					if (catchNode.get(i).toString().contains("\"ifCatch\":true"))
						covered[0] = covered[0] + weight;
				} else if (catchNode.get(i).toString().contains("branch")) {
					JSONObject node = new JSONObject(catchNode.get(i).toString());
					// catchNode中的NodeName 对应 Node里面的name 二者是一样的
					weight = NodeMap.get(node.get("nodeName").toString());
					sum[1] = sum[1] + weight;
					if (catchNode.get(i).toString().contains("\"ifCatch\":true"))
						covered[1] = covered[1] + weight;
				} else if (catchNode.get(i).toString().contains("method")) {
					JSONObject node = new JSONObject(catchNode.get(i).toString());
					weight = NodeMap.get(node.get("nodeName").toString());
					sum[2] = sum[2] + weight;
					System.out.println(catchNode.get(i).toString());
					if (catchNode.get(i).toString().contains("\"ifCatch\":true"))
						covered[2] = covered[2] + weight;
				}
			}
			DecimalFormat dcmFmt = new DecimalFormat("0.00");
			String linescore = dcmFmt.format((covered[0] / sum[0]) * 100);
			String branchscore = dcmFmt.format((covered[1] / sum[1]) * 100);
			String conditionscore = dcmFmt.format((covered[2] / sum[2]) * 100);
			score[0] = linescore;
			score[1] = branchscore;
			score[2] = conditionscore;
			System.out.println(score[0] + "!!!" + score[1] + "???" + score[2]);
		} else {
			score[0] = "run failure";
			score[1] = "run failure";
			score[2] = "run failure";
		}
		return score;
	}
	
	public static void main(String[] args) throws UnsupportedEncodingException, DocumentException {
		System.out.println("start: "+System.currentTimeMillis());
		Scanner in = new Scanner(System.in);
		String path = in.next();
		execCMD(path);
		System.out.println("mvn end: "+System.currentTimeMillis());
		parseXML(path); 
		JSONArray catchNode = CatchJson(path + "/target/mcnode/result/coverage.json");
		JSONObject templateNode = CatchObject(path + "/target/mcnode/result/project.json");
		String[] score = CalculateNode(catchNode, templateNode);
		System.out.println("local end: "+System.currentTimeMillis());
		System.out.println("http end: "+System.currentTimeMillis());
		System.out.println("Line Cov: " + score[0] + " Branch Cov: " + score[1] + " Condition Cov:" + score[2]);
		System.out.println(System.currentTimeMillis());
	}
	
//	public static void main(String[] args) throws UnsupportedEncodingException, DocumentException {
//		  System.out.println("start: "+System.currentTimeMillis());
//		  execSSH2("/Users/insomnialee/mooctest/projects/4214/8212/Nextday");
//		  System.out.println("mvn end: "+System.currentTimeMillis());
//		  parseXML("/Users/insomnialee/mooctest/projects/4214/8212/Nextday"); 
//		  JSONArray catchNode = CatchJson("/Users/insomnialee/mooctest/projects/4214/8212/Nextday/target/mcnode/result/coverage.json");
//		  JSONObject templateNode = CatchObject("/Users/insomnialee/mooctest/projects/4214/8212/Nextday/target/mcnode/result/project.json");
//		  String[] score = CalculateNode(catchNode, templateNode);
//		  System.out.println("local end: "+System.currentTimeMillis());
//		  System.out.println("http end: "+System.currentTimeMillis());
//		  System.out.println(score[0] + "!!!" + score[1] + "???" + score[2]);
//		  System.out.println(System.currentTimeMillis());
//		 }

}
