package com.frk.mycode.branch;

import com.atlassian.clover.registry.entities.TestCaseInfo;

import java.util.List;
import java.util.Objects;

/**
 * @date 2024/4/21
 */
public class BranchResult {
    String filePath;
    Integer branchStartLine;
    boolean isCovered;
    List<TestCaseInfo> testCaseInfo;

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof BranchResult)) return false;

        BranchResult that = (BranchResult) o;

        if (!Objects.equals(filePath, that.filePath)) return false;
        return Objects.equals(branchStartLine, that.branchStartLine);
    }

    @Override
    public int hashCode() {
        int result = filePath != null ? filePath.hashCode() : 0;
        result = 31 * result + (branchStartLine != null ? branchStartLine.hashCode() : 0);
        return result;
    }

    public BranchResult(String filePath, Integer branchStartLine, boolean isCovered) {
        this.filePath = filePath;
        this.branchStartLine = branchStartLine;
        this.isCovered = isCovered;
    }

    public String getFilePath() {
        return filePath;
    }

    public void setFilePath(String filePath) {
        this.filePath = filePath;
    }

    public Integer getBranchStartLine() {
        return branchStartLine;
    }

    public void setBranchStartLine(Integer branchStartLine) {
        this.branchStartLine = branchStartLine;
    }

    public boolean isCovered() {
        return isCovered;
    }

    public void setCovered(boolean covered) {
        isCovered = covered;
    }

    public List<TestCaseInfo> getTestCaseInfo() {
        return testCaseInfo;
    }

    public void setTestCaseInfo(List<TestCaseInfo> testCaseInfo) {
        this.testCaseInfo = testCaseInfo;
    }
}
