package com.frk.mycode.mutation;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

/**
 * @date 2024/5/14
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
public class Mutation {
    private String packageName;
    /**
     * 变异体所在的行号
     */
    private Integer id;

    private String type;
    /**
     * 变异体所在的方法名
     */
    private String location;
    /**
     * 变异体所在的java文件
     */
    private String javaFileName;
    private List<MyTestCase> killedByTestCases;

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof Mutation)) return false;

        Mutation mutation = (Mutation) o;

        if (!getPackageName().equals(mutation.getPackageName())) return false;
        if (!getId().equals(mutation.getId())) return false;
        if (!getType().equals(mutation.getType())) return false;
        if (!getLocation().equals(mutation.getLocation())) return false;
        return getJavaFileName().equals(mutation.getJavaFileName());
    }

    @Override
    public int hashCode() {
        int result = getId().hashCode();
        result = 31 * result + getType().hashCode();
        return result;
    }
}
