package com.frk.main;

import com.alibaba.fastjson.JSONObject;
import com.frk.mycode.PITesrDecrease;
import com.frk.mycode.PITestUtil;
import com.frk.mycode.mutation.Mutation;
import org.apache.commons.io.FileUtils;
import org.junit.Test;

import java.io.*;
import java.nio.charset.StandardCharsets;
import java.util.LinkedHashSet;
import java.util.LinkedList;
import java.util.List;

/**
 * @date 2024/5/17
 */
public class PITest {
    @Test
    public void test() {
        String source = "D:\\learn\\junit-test\\test\\EightQueens_N";
        PITesrDecrease.mutationDecrease(source);
        LinkedHashSet<Mutation> resultList = PITesrDecrease.allMutationInfo;
        String jsonString = JSONObject.toJSONString(resultList);
        File writeFile = new File(source + File.separator + "result.json");
        try(Writer write = new OutputStreamWriter(new FileOutputStream(writeFile), StandardCharsets.UTF_8)) {
            write.write(jsonString);
            write.flush();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
    @Test
    public void testSingle() {
        PITestUtil.runAndParsePITest("D:\\learn\\junit-test\\test\\solve2\\EightQueens_1666011085487");
    }
    @Test
    public void replace() {
        String s = "D:\\learn\\junit-test\\test\\EightQueens_N";
        String t = "D:\\learn\\junit-test\\test\\EightQueensTemplate";

        replaceSourcetoTemplate(s, t);
    }

    public void  replaceSourcetoTemplate(String sourceDirPath, String templateDirPath) {
        File sourceDir = new File(sourceDirPath);
        File[] subProjects = sourceDir.listFiles(File::isDirectory);
        File templateDir = new File(templateDirPath);
        String targetPath = "src" + File.separator + "main" + File.separator + "java" + File.separator + "net" + File.separator + "mooctest";
        if (subProjects != null && subProjects.length > 0) {
                // 遍历所有其他子项目
                for (int i = 0; i < subProjects.length; i++) {
                    File sub = subProjects[i];
                    // 替换每个子项目的 "src\\main\\java\\net\\mooctest" 目录下的 Java 文件
                    File targetSrcDir = new File(sub, targetPath);
                    if (targetSrcDir.exists() && targetSrcDir.isDirectory()) {
                        try {
                        FileUtils.deleteDirectory(targetSrcDir);
                        for (File temp : templateDir.listFiles()) {
                            FileUtils.copyFileToDirectory(temp, targetSrcDir);
                        }
                        } catch (IOException e) {
                            e.printStackTrace();
                        }
                        System.out.println("Copy " + templateDirPath + " to " + sub.getAbsolutePath() + " success !!!" );
                    }
                }
            } else {
                System.out.println("未找到任何Java文件。");
            }
        }
}
